<?php
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.plugin.helper');
class plgJshoppingCheckoutprice_round_to_05 extends JPlugin {
	   
        private $taxRound = FALSE;
    
        function __construct(&$subject, $config)
        {
            parent::__construct($subject, $config);
            $this->loadLanguage();
            $this->taxRound = $this->checkTaxRound();
	}
        
        private function checkTaxRound()
        {
            $addon = JTable::getInstance("addon", "jshop");
            $addon->loadAlias('addon_price_round_to_05');
            
            $addonParams = $addon->getParams();
            $taxRound = $addonParams["tax_round"];
            
            return intval($taxRound) ? TRUE : FALSE;
	}
	
	private function roundTo05Price($value){
		$value = round($value, 2);
		$value_temp = round(10*(10 * $value - floor(10 * $value)));
		if ($value_temp <3){
			$rest = 0;
		} else if ($value_temp <8){
			$rest = 0.05;
		} else {
			$rest = 0.1;
		}
		return floor(10*$value) / 10 + $rest;
	}
	
	public function onAfterCartLoad(&$cart){
		$cart->price_product_brutto = $this->roundTo05Price($cart->price_product_brutto);
	}
		
	public function onBeforeDisplayCartView(&$view){
		$view->fullsumm = $this->roundTo05Price($view->fullsumm);
		if(count($view->tax_list) && $this->taxRound){
			foreach($view->tax_list as $k=>$v){
				$view->tax_list[$k] = $this->roundTo05Price($view->tax_list[$k]);
			}
		}
		if($view->discount)$view->discount = $this->roundTo05Price($view->discount);
	}
	
	public function onBeforeDisplayCheckoutStep3View(&$view){
		if(count($view->payment_methods)){
			foreach($view->payment_methods as $k=>$v){
				if ($view->payment_methods[$k]->price_add_text  && $v->price_type!=2){
					$tmp_arr = explode(' ', $view->payment_methods[$k]->price_add_text);
					$tmp_arr[0] = $this->roundTo05Price((float)$tmp_arr[0]);
					if($tmp_arr[0] > 0)$tmp_arr[0] = '+' . $tmp_arr[0]; 
					$view->payment_methods[$k]->price_add_text = $tmp_arr[0] . ' ' . $tmp_arr[1];
				}
				if($view->payment_methods[$k]->calculeprice)$view->payment_methods[$k]->calculeprice = $this->roundTo05Price($view->payment_methods[$k]->calculeprice);
			}
		}
	}
	
	public function onBeforeDisplayCheckoutStep4View(&$view){
		
		if(count($view->shipping_methods)){
			foreach($view->shipping_methods as $k=>$v){
				if($view->shipping_methods[$k]->calculeprice)$view->shipping_methods[$k]->calculeprice = $this->roundTo05Price($view->shipping_methods[$k]->calculeprice);
			}
		}
	}
	
	public function onBeforeDisplaySmallCart(&$cart){
		
		$session = JFactory::getSession();
		$jshop_price_shipping = $session->get("jshop_price_shipping");
		if($jshop_price_shipping)$session->set("jshop_price_shipping",$this->roundTo05Price($jshop_price_shipping));
		
		$jshop_price_package = $session->get("jshop_price_package");
		if($jshop_price_package)$session->set("jshop_price_package",$this->roundTo05Price($jshop_price_package));
		
		$jshop_payment_price = $session->get("jshop_payment_price");
		if($jshop_payment_price)$session->set("jshop_payment_price",$this->roundTo05Price($jshop_payment_price));
		
	}
	
	public function onBeforeDisplayCheckoutCartView(&$view){
		if($view->tax_list && $this->taxRound){
			foreach($view->tax_list as $k=>$v){
				$view->tax_list[$k] = $this->roundTo05Price($view->tax_list[$k]);
			}
		}
		$view->fullsumm = $this->roundTo05Price($view->fullsumm);
		if($view->discount)$view->discount = $this->roundTo05Price($view->discount);
	}
	
	public function onBeforeCreateOrder(&$order){
		$order->order_total = $this->roundTo05Price($order->order_total);
		$order->order_subtotal = $this->roundTo05Price($order->order_subtotal);
                if($this->taxRound){
                    $order->order_tax = $this->roundTo05Price($order->order_tax);
                }
		$order->order_shipping = $this->roundTo05Price($order->order_shipping);
		$order->order_payment = $this->roundTo05Price($order->order_payment);
		$order->order_discount = $this->roundTo05Price($order->order_discount);
		if($order->order_package)$order->order_package = $this->roundTo05Price($order->order_package);
		
        $order_tax_ext = unserialize($order->order_tax_ext);    
        if($this->taxRound)
        foreach($order_tax_ext as $k=>$v){
            $order_tax_ext[$k] = $this->roundTo05Price($v);
        }        
		$order->order_tax_ext = serialize($order_tax_ext);
	}
}
?>